object EMAboutBox: TEMAboutBox
  Left = 242
  Top = 116
  BorderStyle = bsDialog
  Caption = 'About'
  ClientHeight = 479
  ClientWidth = 386
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'MS Sans Serif'
  Font.Style = []
  OldCreateOrder = True
  Position = poScreenCenter
  PixelsPerInch = 96
  TextHeight = 13
  object Panel1: TPanel
    Left = 8
    Top = 8
    Width = 281
    Height = 73
    BevelInner = bvRaised
    BevelOuter = bvLowered
    ParentColor = True
    TabOrder = 0
    object ProgramIcon: TImage
      Left = 8
      Top = 8
      Width = 65
      Height = 57
      Picture.Data = {
        07544269746D617076020000424D760200000000000076000000280000002000
        0000200000000100040000000000000200000000000000000000100000000000
        000000000000000080000080000000808000800000008000800080800000C0C0
        C000808080000000FF0000FF000000FFFF00FF000000FF00FF00FFFF0000FFFF
        FF00000000000000000000000000000000000EE8787878EEEEEEE03F30878EEE
        EEE00EE8787878EEEEEEE03F30878EEEEEE00EE8787878EEEEEEE03F30878EEE
        EEE00EE8787878EEEEEEE03F30878EEEEEE00887787877788888803F3088787E
        EEE00788787878878887803F3088887EEEE00788887888878887803F3088887E
        EEE00877888887788888703F308887EEEEE00888777778888888037883088888
        8EE007777777777777703787883087777EE00888888888888803787FF8830888
        888008888888888880378777778830888880077777777788037873F3F3F87808
        88E00888888888803787FFFFFFFF8830EEE00887777778800001111111111100
        EEE00888888888888899B999B99999EEEEE00888888888888899B9B99BB9B9EE
        EEE0088888888888899BB9BB99BB99EEEEE0078888888888899B999B999999EE
        EEE0087788888778899B9B9BB9BB99EEEEE00888778778888E9B9B9BB9999EEE
        EEE0088888788888EE9B99B9BB9BEEEEEEE00EE8888888EEEEE999B9999EEEEE
        EEE00EEEE888EEEEEEEE99BB999EEEEEEEE00EEEEE8EEEEEEEEEE999B9EEEEEE
        EEE00EEEEE8EEEEEEEEEEEE999EEEEEEEEE00EEEEE8EEEEEEEEEEEEE99EEEEEE
        EEE00EEEEE8EEEEEEEEEEEEE9EEEEEEEEEE00EEEEE8EEEEEEEEEEEEEEEEEEEEE
        EEE00EEEEEEEEEEEEEEEEEEEEEEEEEEEEEE00000000000000000000000000000
        0000}
      Stretch = True
      IsControl = True
    end
  end
  object OKButton: TButton
    Left = 143
    Top = 452
    Width = 75
    Height = 25
    Caption = 'OK'
    Default = True
    ModalResult = 1
    TabOrder = 1
  end
  object Memo1: TMemo
    Left = 8
    Top = 88
    Width = 369
    Height = 353
    Lines.Strings = (
      'This is a work in progress. '
      
        'Built with Delphi 3, ported to Delphi 7, but code should compile' +
        ' with '
      'Lazarus.'
      '(c) Laurie Boshell 2004 thru 2019'
      ''
      'OTHER PEOPLE'#39'S CODE'
      '1. Z80 core in Delphi/Lazarus by Leniad: DSP homepage at '
      'leniad.cjb.net'
      '2. CRT Component MJWCRT by Michael Wilcox: '
      'mwilcox@economat.demon.co.uk.'
      ''
      'HOW DOES IT WORK?'
      
        'The Z80 core has been patched a little by me. I have repaired a ' +
        'bug in '
      
        'the disassembler and changed the opcode fetch routine to allow t' +
        'rapping '
      'and breakpoints.'
      
        'I have done a very rudimentary emulation of the CP/M bios (CALL ' +
        '0000) '
      
        'functions 0 to 13, and 4 functions for the CP/M BDOS (CALL 0005)' +
        '. This '
      
        'is not a full implementation of CP/M, however you could extend t' +
        'he bios '
      'and it would then host CP/M.  The Z80 emulation passes the Z80 '
      
        'instruction set exerciser with NO errors.  You will find ZEXALL ' +
        'at '
      'http://mdfs.net/Software/Z80/Exerciser/.'
      ''
      'The BDOS and BIOS calls supported are listed here.'
      ' '
      'BDOS calls (Call $0005) emulated....'
      '    0 : system reset'
      '    1 : Wait for char, echo and return Returns A=L=character.'
      '    2 : Write character in register E'
      
        '    9 : Write character string pointed to by register DE until '#39 +
        '$'#39' encounted.'
      ''
      'BIOS calls emulated (Call $0000)'
      '    0 : CPMWBOOT'
      '    1 : CPMCONST  //'
      '    2 : CONIN     //Wait for char, return it in A'
      '    3 : CONOUT'
      '    4 : LIST      //Does nothing'
      '    5 : PUNCH     //Does nothing'
      '    6 : READER    //Does nothing'
      '    7 : CPMHOME   //Home current disk...goto T0'
      '    8 : CPMSELDSK //in C, 0=a, 1=b etc'
      '    9 : SETTRK    //Set track'
      '    10: SETSEC    //Set sector'
      '    11: SETDMA    //Set DMA for sector read/write'
      '    12: READ      //Read sector'
      '    13: WRITE     //Write sector '
      ''
      'HOW DO I GET CONTROL OF THE CP/M FUNCTIONS?'
      ''
      'I make $0000 look like JMP FE03, and $0005 like JMP FF00.'
      
        'The Z80 interpreter traps any opcode fetch in these address rang' +
        'es, '
      'examines the Z80 address and index registers and implements the '
      
        'function in Pascal code, then returns control by executing a Z80' +
        ' "return '
      'from call" opcode. It works like magic! '
      '     '
      ''
      'Help needed.'
      'I'#39'll port it to Linux/Lazarus if anyone can convert the MJWCRT '
      
        'component from Delphi to Lazarus and make the read key work with' +
        ' '
      'flashing cursor in Lazarus.  Send me a PM through the Yahoo '
      'UCSDPASCAL group or use the email address below.'
      ''
      'Laurie Boshell      laurieboshell at gmail dot com')
    ScrollBars = ssVertical
    TabOrder = 2
  end
end
