unit Z80Int;
interface
//OPCODE [29] is DEC E.  Corrected by Laurie Boshell (LB)
Var
  opcode,opcodeCB,opcodeDD,opcodeDDCB,
  opcodeED,opcodeFD,opcodeFDCB             : array[0..255] of string[13];

procedure dis1;

implementation


procedure dis1;
var i:integer;
begin
  opcode[  0]:='NOP          ';
  opcode[  1]:='LD   BC,n   2';
  opcode[  2]:='LD   (BC),A  ';
  opcode[  3]:='INC  BC      ';
  opcode[  4]:='INC  B       ';
  opcode[  5]:='DEC  B       ';
  opcode[  6]:='LD   B,n    1';
  opcode[  7]:='RLCA         ';
  opcode[  8]:='EX   AF,AF~  ';
  opcode[  9]:='ADD  HL,BC   ';
  opcode[ 10]:='LD   A,(BC)  ';
  opcode[ 11]:='DEC  BC      ';
  opcode[ 12]:='INC  C       ';
  opcode[ 13]:='DEC  C       ';
  opcode[ 14]:='LD   C,n    1';
  opcode[ 15]:='RRCA         ';
  opcode[ 16]:='DJNZ n      3';
  opcode[ 17]:='LD   DE,n   2';
  opcode[ 18]:='LD   (DE),A  ';
  opcode[ 19]:='INC  DE      ';
  opcode[ 20]:='INC  D       ';
  opcode[ 21]:='DEC  D       ';
  opcode[ 22]:='LD   D,n    1';
  opcode[ 23]:='RLA          ';
  opcode[ 24]:='JR   n      3';
  opcode[ 25]:='ADD  HL,DE   ';
  opcode[ 26]:='LD   A,(DE)  ';
  opcode[ 27]:='DEC  DE      ';
  opcode[ 28]:='INC  E       ';
  opcode[ 29]:='DEC  E       ';      //29 not 39 LB
  opcode[ 30]:='LD   E,n    1';
  opcode[ 31]:='RRA          ';
  opcode[ 32]:='JR   NZ,n   3';
  opcode[ 33]:='LD   HL,n   2';
  opcode[ 34]:='LD   (n),HL 2';
  opcode[ 35]:='INC  HL      ';
  opcode[ 36]:='INC  H       ';
  opcode[ 37]:='DEC  H       ';
  opcode[ 38]:='LD   H,n    1';
  opcode[ 39]:='DAA          ';
  opcode[ 40]:='JR   Z,n    3';
  opcode[ 41]:='ADD  HL,HL   ';
  opcode[ 42]:='LD   HL,(n) 2';
  opcode[ 43]:='DEC  HL      ';
  opcode[ 44]:='INC  L       ';
  opcode[ 45]:='DEC  L       ';
  opcode[ 46]:='LD   D,n    1';
  opcode[ 47]:='CPL          ';
  opcode[ 48]:='JR   NC,n   3';
  opcode[ 49]:='LD   SP,n   2';
  opcode[ 50]:='LD   (n),A  2';
  opcode[ 51]:='INC  SP      ';
  opcode[ 52]:='INC  (HL)    ';
  opcode[ 53]:='DEC  (HL)    ';
  opcode[ 54]:='LD   (HL),n 1';
  opcode[ 55]:='SCF          ';
  opcode[ 56]:='JR   C,n    3';
  opcode[ 57]:='ADD  HL,SP   ';
  opcode[ 58]:='LD   A,(n)  2';
  opcode[ 59]:='DEC  SP      ';
  opcode[ 60]:='INC  A       ';
  opcode[ 61]:='DEC  A       ';
  opcode[ 62]:='LD   A,n    1';
  opcode[ 63]:='CCF          ';
  opcode[ 64]:='LD   B,B     ';
  opcode[ 65]:='LD   B,C     ';
  opcode[ 66]:='LD   B,D     ';
  opcode[ 67]:='LD   B,E     ';
  opcode[ 68]:='LD   B,H     ';
  opcode[ 69]:='LD   B,L     ';
  opcode[ 70]:='LD   B,(HL)  ';
  opcode[ 71]:='LD   B,A     ';
  opcode[ 72]:='LD   C,B     ';
  opcode[ 73]:='LD   C,C     ';
  opcode[ 74]:='LD   C,D     ';
  opcode[ 75]:='LD   C,E     ';
  opcode[ 76]:='LD   C,H     ';
  opcode[ 77]:='LD   C,L     ';
  opcode[ 78]:='LD   C,(HL)  ';
  opcode[ 79]:='LD   C,A     ';
  opcode[ 80]:='LD   D,B     ';
  opcode[ 81]:='LD   D,C     ';
  opcode[ 82]:='LD   D,D     ';
  opcode[ 83]:='LD   D,E     ';
  opcode[ 84]:='LD   D,H     ';
  opcode[ 85]:='LD   D,L     ';
  opcode[ 86]:='LD   D,(HL)  ';
  opcode[ 87]:='LD   D,A     ';
  opcode[ 88]:='LD   E,B     ';
  opcode[ 89]:='LD   E,C     ';
  opcode[ 90]:='LD   E,D     ';
  opcode[ 91]:='LD   E,E     ';
  opcode[ 92]:='LD   E,H     ';
  opcode[ 93]:='LD   E,L     ';
  opcode[ 94]:='LD   E,(HL)  ';
  opcode[ 95]:='LD   E,A     ';
  opcode[ 96]:='LD   H,B     ';
  opcode[ 97]:='LD   H,C     ';
  opcode[ 98]:='LD   H,D     ';
  opcode[ 99]:='LD   H,E     ';
  opcode[100]:='LD   H,H     ';
  opcode[101]:='LD   H,L     ';
  opcode[102]:='LD   H,(HL)  ';
  opcode[103]:='LD   H,A     ';
  opcode[104]:='LD   L,B     ';
  opcode[105]:='LD   L,C     ';
  opcode[106]:='LD   L,D     ';
  opcode[107]:='LD   L,E     ';
  opcode[108]:='LD   L,H     ';
  opcode[109]:='LD   L,L     ';
  opcode[110]:='LD   L,(HL)  ';
  opcode[111]:='LD   L,A     ';
  opcode[112]:='LD   (HL),B  ';
  opcode[113]:='LD   (HL),C  ';
  opcode[114]:='LD   (HL),D  ';
  opcode[115]:='LD   (HL),E  ';
  opcode[116]:='LD   (HL),H  ';
  opcode[117]:='LD   (HL),L  ';
  opcode[118]:='HALT         ';
  opcode[119]:='LD   (HL),A  ';
  opcode[120]:='LD   A,B     ';
  opcode[121]:='LD   A,C     ';
  opcode[122]:='LD   A,D     ';
  opcode[123]:='LD   A,E     ';
  opcode[124]:='LD   A,H     ';
  opcode[125]:='LD   A,L     ';
  opcode[126]:='LD   A,(HL)  ';
  opcode[127]:='LD   A,A     ';
  opcode[128]:='ADD  A,B     ';
  opcode[129]:='ADD  A,C     ';
  opcode[130]:='ADD  A,D     ';
  opcode[131]:='ADD  A,E     ';
  opcode[132]:='ADD  A,H     ';
  opcode[133]:='ADD  A,L     ';
  opcode[134]:='ADD  A,(HL)  ';
  opcode[135]:='ADD  A,A     ';
  opcode[136]:='ADC  A,B     ';
  opcode[137]:='ADC  A,C     ';
  opcode[138]:='ADC  A,D     ';
  opcode[139]:='ADC  A,E     ';
  opcode[140]:='ADC  A,H     ';
  opcode[141]:='ADC  A,L     ';
  opcode[142]:='ADC  A,(HL)  ';
  opcode[143]:='ADC  A,A     ';
  opcode[144]:='SUB  B       ';
  opcode[145]:='SUB  C       ';
  opcode[146]:='SUB  D       ';
  opcode[147]:='SUB  E       ';
  opcode[148]:='SUB  H       ';
  opcode[149]:='SUB  L       ';
  opcode[150]:='SUB  (HL)    ';
  opcode[151]:='SUB  A       ';
  opcode[152]:='SBC  A,B     ';
  opcode[153]:='SBC  A,C     ';
  opcode[154]:='SBC  A,D     ';
  opcode[155]:='SBC  A,E     ';
  opcode[156]:='SBC  A,H     ';
  opcode[157]:='SBC  A,L     ';
  opcode[158]:='SBC  A,(HL)  ';
  opcode[159]:='SBC  A,A     ';
  opcode[160]:='AND  B       ';
  opcode[161]:='AND  C       ';
  opcode[162]:='AND  D       ';
  opcode[163]:='AND  E       ';
  opcode[164]:='AND  H       ';
  opcode[165]:='AND  L       ';
  opcode[166]:='AND  (HL)    ';
  opcode[167]:='AND  A       ';
  opcode[168]:='XOR  B       ';
  opcode[169]:='XOR  C       ';
  opcode[170]:='XOR  D       ';
  opcode[171]:='XOR  E       ';
  opcode[172]:='XOR  H       ';
  opcode[173]:='XOR  L       ';
  opcode[174]:='XOR  (HL)    ';
  opcode[175]:='XOR  A       ';
  opcode[176]:='OR   B       ';
  opcode[177]:='OR   C       ';
  opcode[178]:='OR   D       ';
  opcode[179]:='OR   E       ';
  opcode[180]:='OR   H       ';
  opcode[181]:='OR   L       ';
  opcode[182]:='OR   (HL)    ';
  opcode[183]:='OR   A       ';
  opcode[184]:='CP   B       ';
  opcode[185]:='CP   C       ';
  opcode[186]:='CP   D       ';
  opcode[187]:='CP   E       ';
  opcode[188]:='CP   H       ';
  opcode[189]:='CP   L       ';
  opcode[190]:='CP   (HL)    ';
  opcode[191]:='CP   A       ';
  opcode[192]:='RET  NZ      ';
  opcode[193]:='POP  BC      ';
  opcode[194]:='JP   NZ,n   2';
  opcode[195]:='JP   n      2';
  opcode[196]:='CALL NZ,n   2';
  opcode[197]:='PUSH BC      ';
  opcode[198]:='ADD  A,n    1';
  opcode[199]:='RST  0       ';
  opcode[200]:='RET  Z       ';
  opcode[201]:='RET          ';
  opcode[202]:='JP   Z,n    2';
  opcode[203]:='???         9';
  opcode[204]:='CALL Z,n    2';
  opcode[205]:='CALL n      2';
  opcode[206]:='ADC  A,n    1';
  opcode[207]:='RST  8H      ';
  opcode[208]:='RET  NC      ';
  opcode[209]:='POP  DE      ';
  opcode[210]:='JP   NC,n   2';
  opcode[211]:='OUT  (n),A  1';
  opcode[212]:='CALL NC,n   2';
  opcode[213]:='PUSH DE      ';
  opcode[214]:='SUB  n      1';
  opcode[215]:='RST  10H     ';
  opcode[216]:='RET  C       ';
  opcode[217]:='EXX          ';
  opcode[218]:='JP   C,n    2';
  opcode[219]:='IN   A,n    1';
  opcode[220]:='CALL C,n    2';
  opcode[221]:='???         9';
  opcode[222]:='SBC  A,n    1';
  opcode[223]:='RST  18H     ';
  opcode[224]:='RET  PO      ';
  opcode[225]:='POP  HL      ';
  opcode[226]:='JP   PO,n   2';
  opcode[227]:='EX   (SP),HL ';
  opcode[228]:='CALL PO,n   2';
  opcode[229]:='PUSH HL      ';
  opcode[230]:='AND  n      1';
  opcode[231]:='RST  20H     ';
  opcode[232]:='RET  PE      ';
  opcode[233]:='JP   (HL)    ';   //E9
  opcode[234]:='JP   PE,n   2';
  opcode[235]:='EX   DE,HL   ';
  opcode[236]:='CALL PE,n   2';
  opcode[237]:='???         9';
  opcode[238]:='XOR  n      1';
  opcode[239]:='RST  28H     ';
  opcode[240]:='RET  P       ';
  opcode[241]:='POP  AF      ';
  opcode[242]:='JP   P,n    2';
  opcode[243]:='DI           ';
  opcode[244]:='CALL P,n    2';
  opcode[245]:='PUSH AF      ';
  opcode[246]:='OR   n      1';
  opcode[247]:='RST  30H     ';
  opcode[248]:='RET  M       ';
  opcode[249]:='LD   SP,HL   ';
  opcode[250]:='JP   M,n    2';
  opcode[251]:='EI           ';
  opcode[252]:='CALL M,n    2';
  opcode[253]:='???         9';
  opcode[254]:='CP   n      1';
  opcode[255]:='RST 38H      ';

  opcodeCB[  0]:='RLC  B       ';
  opcodeCB[  1]:='RLC  C       ';
  opcodeCB[  2]:='RLC  D       ';
  opcodeCB[  3]:='RLC  E       ';
  opcodeCB[  4]:='RLC  H       ';
  opcodeCB[  5]:='RLC  L       ';
  opcodeCB[  6]:='RLC  (HL)    ';
  opcodeCB[  7]:='RLC  A       ';
  opcodeCB[  8]:='RRC  B       ';
  opcodeCB[  9]:='RRC  C       ';
  opcodeCB[ 10]:='RRC  D       ';
  opcodeCB[ 11]:='RRC  E       ';
  opcodeCB[ 12]:='RRC  H       ';
  opcodeCB[ 13]:='RRC  L       ';
  opcodeCB[ 14]:='RRC  (HL)    ';
  opcodeCB[ 15]:='RRC  A       ';
  opcodeCB[ 16]:='RL   B       ';
  opcodeCB[ 17]:='RL   C       ';
  opcodeCB[ 18]:='RL   D       ';
  opcodeCB[ 19]:='RL   E       ';
  opcodeCB[ 20]:='RL   H       ';
  opcodeCB[ 21]:='RL   L       ';
  opcodeCB[ 22]:='RL   (HL)    ';
  opcodeCB[ 23]:='RL   A       ';
  opcodeCB[ 24]:='RR   B       ';
  opcodeCB[ 25]:='RR   C       ';
  opcodeCB[ 26]:='RR   D       ';
  opcodeCB[ 27]:='RR   E       ';
  opcodeCB[ 28]:='RR   H       ';
  opcodeCB[ 29]:='RR   L       ';
  opcodeCB[ 30]:='RR   (HL)    ';
  opcodeCB[ 31]:='RR   A       ';
  opcodeCB[ 32]:='SLA  B       ';
  opcodeCB[ 33]:='SLA  C       ';
  opcodeCB[ 34]:='SLA  D       ';
  opcodeCB[ 35]:='SLA  E       ';
  opcodeCB[ 36]:='SLA  H       ';
  opcodeCB[ 37]:='SLA  L       ';
  opcodeCB[ 38]:='SLA  (HL)    ';
  opcodeCB[ 39]:='SLA  A       ';
  opcodeCB[ 40]:='SRA  B       ';
  opcodeCB[ 41]:='SRA  C       ';
  opcodeCB[ 42]:='SRA  D       ';
  opcodeCB[ 43]:='SRA  E       ';
  opcodeCB[ 44]:='SRA  H       ';
  opcodeCB[ 45]:='SRA  L       ';
  opcodeCB[ 46]:='SRA  (HL)    ';
  opcodeCB[ 47]:='SRA  A       ';
  for i:=0 to 7 do opcodeCB[48+i]:='????         ';
  opcodeCB[ 56]:='SRL  B       ';
  opcodeCB[ 57]:='SRL  C       ';
  opcodeCB[ 58]:='SRL  D       ';
  opcodeCB[ 59]:='SRL  E       ';
  opcodeCB[ 60]:='SRL  H       ';
  opcodeCB[ 61]:='SRL  L       ';
  opcodeCB[ 62]:='SRL  (HL)    ';
  opcodeCB[ 63]:='SRL  A       ';
  opcodeCB[ 64]:='BIT  0,B     ';
  opcodeCB[ 65]:='BIT  0,C     ';
  opcodeCB[ 66]:='BIT  0,D     ';
  opcodeCB[ 67]:='BIT  0,E     ';
  opcodeCB[ 68]:='BIT  0,H     ';
  opcodeCB[ 69]:='BIT  0,L     ';
  opcodeCB[ 70]:='BIT  0,(HL)  ';
  opcodeCB[ 71]:='BIT  0,A     ';
  opcodeCB[ 72]:='BIT  1,B     ';
  opcodeCB[ 73]:='BIT  1,C     ';
  opcodeCB[ 74]:='BIT  1,D     ';
  opcodeCB[ 75]:='BIT  1,E     ';
  opcodeCB[ 76]:='BIT  1,H     ';
  opcodeCB[ 77]:='BIT  1,L     ';
  opcodeCB[ 78]:='BIT  1,(HL)  ';
  opcodeCB[ 79]:='BIT  1,A     ';
  opcodeCB[ 80]:='BIT  2,B     ';
  opcodeCB[ 81]:='BIT  2,C     ';
  opcodeCB[ 82]:='BIT  2,D     ';
  opcodeCB[ 83]:='BIT  2,E     ';
  opcodeCB[ 84]:='BIT  2,H     ';
  opcodeCB[ 85]:='BIT  2,L     ';
  opcodeCB[ 86]:='BIT  2,(HL)  ';
  opcodeCB[ 87]:='BIT  2,A     ';
  opcodeCB[ 88]:='BIT  3,B     ';
  opcodeCB[ 89]:='BIT  3,C     ';
  opcodeCB[ 90]:='BIT  3,D     ';
  opcodeCB[ 91]:='BIT  3,E     ';
  opcodeCB[ 92]:='BIT  3,H     ';
  opcodeCB[ 93]:='BIT  3,L     ';
  opcodeCB[ 94]:='BIT  3,(HL)  ';
  opcodeCB[ 95]:='BIT  3,A     ';
  opcodeCB[ 96]:='BIT  4,B     ';
  opcodeCB[ 97]:='BIT  4,C     ';
  opcodeCB[ 98]:='BIT  4,D     ';
  opcodeCB[ 99]:='BIT  4,E     ';
  opcodeCB[100]:='BIT  4,H     ';
  opcodeCB[101]:='BIT  4,L     ';
  opcodeCB[102]:='BIT  4,(HL)  ';
  opcodeCB[103]:='BIT  4,A     ';
  opcodeCB[104]:='BIT  5,B     ';
  opcodeCB[105]:='BIT  5,C     ';
  opcodeCB[106]:='BIT  5,D     ';
  opcodeCB[107]:='BIT  5,E     ';
  opcodeCB[108]:='BIT  5,H     ';
  opcodeCB[109]:='BIT  5,L     ';
  opcodeCB[110]:='BIT  5,(HL)  ';
  opcodeCB[111]:='BIT  5,A     ';
  opcodeCB[112]:='BIT  6,B     ';
  opcodeCB[113]:='BIT  6,C     ';
  opcodeCB[114]:='BIT  6,D     ';
  opcodeCB[115]:='BIT  6,E     ';
  opcodeCB[116]:='BIT  6,H     ';
  opcodeCB[117]:='BIT  6,L     ';
  opcodeCB[118]:='BIT  6,(HL)  ';
  opcodeCB[119]:='BIT  6,A     ';
  opcodeCB[120]:='BIT  7,B     ';
  opcodeCB[121]:='BIT  7,C     ';
  opcodeCB[122]:='BIT  7,D     ';
  opcodeCB[123]:='BIT  7,E     ';
  opcodeCB[124]:='BIT  7,H     ';
  opcodeCB[125]:='BIT  7,L     ';
  opcodeCB[126]:='BIT  7,(HL)  ';
  opcodeCB[127]:='BIT  7,A     ';
  opcodeCB[128]:='RES  0,B     ';
  opcodeCB[129]:='RES  0,C     ';
  opcodeCB[130]:='RES  0,D     ';
  opcodeCB[131]:='RES  0,E     ';
  opcodeCB[132]:='RES  0,H     ';
  opcodeCB[133]:='RES  0,L     ';
  opcodeCB[134]:='RES  0,(HL)  ';
  opcodeCB[135]:='RES  0,A     ';
  opcodeCB[136]:='RES  1,B     ';
  opcodeCB[137]:='RES  1,C     ';
  opcodeCB[138]:='RES  1,D     ';
  opcodeCB[139]:='RES  1,E     ';
  opcodeCB[140]:='RES  1,H     ';
  opcodeCB[141]:='RES  1,L     ';
  opcodeCB[142]:='RES  1,(HL)  ';
  opcodeCB[143]:='RES  1,A     ';
  opcodeCB[144]:='RES  2,B     ';
  opcodeCB[145]:='RES  2,C     ';
  opcodeCB[146]:='RES  2,D     ';
  opcodeCB[147]:='RES  2,E     ';
  opcodeCB[148]:='RES  2,H     ';
  opcodeCB[149]:='RES  2,L     ';
  opcodeCB[150]:='RES  2,(HL)  ';
  opcodeCB[151]:='RES  2,A     ';
  opcodeCB[152]:='RES  3,B     ';
  opcodeCB[153]:='RES  3,C     ';
  opcodeCB[154]:='RES  3,D     ';
  opcodeCB[155]:='RES  3,E     ';
  opcodeCB[156]:='RES  3,H     ';
  opcodeCB[157]:='RES  3,L     ';
  opcodeCB[158]:='RES  3,(HL)  ';
  opcodeCB[159]:='RES  3,A     ';
  opcodeCB[160]:='RES  4,B     ';
  opcodeCB[161]:='RES  4,C     ';
  opcodeCB[162]:='RES  4,D     ';
  opcodeCB[163]:='RES  4,E     ';
  opcodeCB[164]:='RES  4,H     ';
  opcodeCB[165]:='RES  4,L     ';
  opcodeCB[166]:='RES  4,(HL)  ';
  opcodeCB[167]:='RES  4,A     ';
  opcodeCB[168]:='RES  5,B     ';
  opcodeCB[169]:='RES  5,C     ';
  opcodeCB[170]:='RES  5,D     ';
  opcodeCB[171]:='RES  5,E     ';
  opcodeCB[172]:='RES  5,H     ';
  opcodeCB[173]:='RES  5,L     ';
  opcodeCB[174]:='RES  5,(HL)  ';
  opcodeCB[175]:='RES  5,A     ';
  opcodeCB[176]:='RES  6,B     ';
  opcodeCB[177]:='RES  6,C     ';
  opcodeCB[178]:='RES  6,D     ';
  opcodeCB[179]:='RES  6,E     ';
  opcodeCB[180]:='RES  6,H     ';
  opcodeCB[181]:='RES  6,L     ';
  opcodeCB[182]:='RES  6,(HL)  ';
  opcodeCB[183]:='RES  6,A     ';
  opcodeCB[184]:='RES  7,B     ';
  opcodeCB[185]:='RES  7,C     ';
  opcodeCB[186]:='RES  7,D     ';
  opcodeCB[187]:='RES  7,E     ';
  opcodeCB[188]:='RES  7,H     ';
  opcodeCB[189]:='RES  7,L     ';
  opcodeCB[190]:='RES  7,(HL)  ';
  opcodeCB[191]:='RES  7,A     ';
  opcodeCB[192]:='SET  0,B     ';
  opcodeCB[193]:='SET  0,C     ';
  opcodeCB[194]:='SET  0,D     ';
  opcodeCB[195]:='SET  0,E     ';
  opcodeCB[196]:='SET  0,H     ';
  opcodeCB[197]:='SET  0,L     ';
  opcodeCB[198]:='SET  0,(HL)  ';
  opcodeCB[199]:='SET  0,A     ';
  opcodeCB[200]:='SET  1,B     ';
  opcodeCB[201]:='SET  1,C     ';
  opcodeCB[202]:='SET  1,D     ';
  opcodeCB[203]:='SET  1,E     ';
  opcodeCB[204]:='SET  1,H     ';
  opcodeCB[205]:='SET  1,L     ';
  opcodeCB[206]:='SET  1,(HL)  ';
  opcodeCB[207]:='SET  1,A     ';
  opcodeCB[208]:='SET  2,B     ';
  opcodeCB[209]:='SET  2,C     ';
  opcodeCB[210]:='SET  2,D     ';
  opcodeCB[211]:='SET  2,E     ';
  opcodeCB[212]:='SET  2,H     ';
  opcodeCB[213]:='SET  2,L     ';
  opcodeCB[214]:='SET  2,(HL)  ';
  opcodeCB[215]:='SET  2,A     ';
  opcodeCB[216]:='SET  3,B     ';
  opcodeCB[217]:='SET  3,C     ';
  opcodeCB[218]:='SET  3,D     ';
  opcodeCB[219]:='SET  3,E     ';
  opcodeCB[220]:='SET  3,H     ';
  opcodeCB[221]:='SET  3,L     ';
  opcodeCB[222]:='SET  3,(HL)  ';
  opcodeCB[223]:='SET  3,A     ';
  opcodeCB[224]:='SET  4,B     ';
  opcodeCB[225]:='SET  4,C     ';
  opcodeCB[226]:='SET  4,D     ';
  opcodeCB[227]:='SET  4,E     ';
  opcodeCB[228]:='SET  4,H     ';
  opcodeCB[229]:='SET  4,L     ';
  opcodeCB[230]:='SET  4,(HL)  ';
  opcodeCB[231]:='SET  4,A     ';
  opcodeCB[232]:='SET  5,B     ';
  opcodeCB[233]:='SET  5,C     ';
  opcodeCB[234]:='SET  5,D     ';
  opcodeCB[235]:='SET  5,E     ';
  opcodeCB[236]:='SET  5,H     ';
  opcodeCB[237]:='SET  5,L     ';
  opcodeCB[238]:='SET  5,(HL)  ';
  opcodeCB[239]:='SET  5,A     ';
  opcodeCB[240]:='SET  6,B     ';
  opcodeCB[241]:='SET  6,C     ';
  opcodeCB[242]:='SET  6,D     ';
  opcodeCB[243]:='SET  6,E     ';
  opcodeCB[244]:='SET  6,H     ';
  opcodeCB[245]:='SET  6,L     ';
  opcodeCB[246]:='SET  6,(HL)  ';
  opcodeCB[247]:='SET  6,A     ';
  opcodeCB[248]:='SET  7,B     ';
  opcodeCB[249]:='SET  7,C     ';
  opcodeCB[250]:='SET  7,D     ';
  opcodeCB[251]:='SET  7,E     ';
  opcodeCB[252]:='SET  7,H     ';
  opcodeCB[253]:='SET  7,L     ';
  opcodeCB[254]:='SET  7,(HL)  ';
  opcodeCB[255]:='SET  7,A     ';


  for i:=0 to 255 do opcodeDD[i]:='????         ';

  opcodeDD[  9]:='ADD  IX,BC   ';
  opcodeDD[ 25]:='ADD  IX,DE   ';
  opcodeDD[ 33]:='LD   IX,n   2';
  opcodeDD[ 34]:='LD   (n),IX 2';
  opcodeDD[ 35]:='INC  IX      ';
  opcodeDD[ 41]:='ADD  IX,IX   ';
  opcodeDD[ 42]:='LD   IX,(n) 2';
  opcodeDD[ 43]:='DEC  IX      ';
  opcodeDD[ 52]:='INC  (IX+n) 1';
  opcodeDD[ 53]:='DEC  (IX+n) 1';
  opcodeDD[ 54]:='LD  (IX+i),n4';
  opcodeDD[ 57]:='ADD  IX,SP   ';
  opcodeDD[ 70]:='LD  B,(IX+n)1';
  opcodeDD[ 78]:='LD  C,(IX+n)1';
  opcodeDD[ 86]:='LD  D,(IX+n)1';
  opcodeDD[ 94]:='LD  E,(IX+n)1';
  opcodeDD[102]:='LD  H,(IX+n)1';
  opcodeDD[110]:='LD  L,(IX+n)1';
  opcodeDD[112]:='LD  (IX+n),B1';
  opcodeDD[113]:='LD  (IX+n),C1';
  opcodeDD[114]:='LD  (IX+n),D1';
  opcodeDD[115]:='LD  (IX+n),E1';
  opcodeDD[116]:='LD  (IX+n),H1';
  opcodeDD[117]:='LD  (IX+n),L1';
  opcodeDD[119]:='LD  (IX+n),A1';
  opcodeDD[126]:='LD  A,(IX+n)1';
  opcodeDD[134]:='ADD A,(IX+n)1';
  opcodeDD[142]:='ADC A,(IX+n)1';
  opcodeDD[150]:='SUB  (IX+n) 1';
  opcodeDD[158]:='SBC  (IX+n) 1';
  opcodeDD[166]:='AND  (IX+n) 1';
  opcodeDD[174]:='XOR  (IX+n) 1';
  opcodeDD[182]:='OR   (IX+n) 1';
  opcodeDD[190]:='CP   (IX+n) 1';
  opcodeDD[203]:='???         9';
  opcodeDD[225]:='POP  IX      ';
  opcodeDD[227]:='EX   (SP),IX ';
  opcodeDD[229]:='PUSH IX      ';
  opcodeDD[233]:='JP   (IX)    ';
  opcodeDD[249]:='LD   SP,IX   ';


  for i:=0 to 255 do opcodeDDCb[i]:='????         ';

  opcodeDDCB[  6]:='RLC  (IX+n) 1';
  opcodeDDCB[ 14]:='RRC  (IX+n) 1';
  opcodeDDCB[ 22]:='RL   (IX+n) 1';
  opcodeDDCB[ 30]:='RR   (IX+n) 1';
  opcodeDDCB[ 38]:='SLA  (IX+n) 1';
  opcodeDDCB[ 46]:='SRA  (IX+n) 1';
  opcodeDDCB[ 62]:='SRL  (IX+n) 1';
  opcodeDDCB[ 70]:='BIT 0,(IX+n)1';
  opcodeDDCB[ 78]:='BIT 1,(IX+n)1';
  opcodeDDCB[ 86]:='BIT 2,(IX+n)1';
  opcodeDDCB[ 94]:='BIT 3,(IX+n)1';
  opcodeDDCB[102]:='BIT 4,(IX+n)1';
  opcodeDDCB[110]:='BIT 5,(IX+n)1';
  opcodeDDCB[118]:='BIT 6,(IX+n)1';
  opcodeDDCB[126]:='BIT 7,(IX+n)1';
  opcodeDDCB[134]:='RES 0,(IX+n)1';
  opcodeDDCB[142]:='RES 1,(IX+n)1';
  opcodeDDCB[150]:='RES 2,(IX+n)1';
  opcodeDDCB[158]:='RES 3,(IX+n)1';
  opcodeDDCB[166]:='RES 4,(IX+n)1';
  opcodeDDCB[174]:='RES 5,(IX+n)1';
  opcodeDDCB[182]:='RES 6,(IX+n)1';
  opcodeDDCB[190]:='RES 7,(IX+n)1';
  opcodeDDCB[198]:='SET 0,(IX+n)1';
  opcodeDDCB[206]:='SET 1,(IX+n)1';
  opcodeDDCB[214]:='SET 2,(IX+n)1';
  opcodeDDCB[222]:='SET 3,(IX+n)1';
  opcodeDDCB[230]:='SET 4,(IX+n)1';
  opcodeDDCB[238]:='SET 5,(IX+n)1';
  opcodeDDCB[246]:='SET 6,(IX+n)1';
  opcodeDDCB[254]:='SET 7,(IX+n)1';


  for i:=0 to 255 do opcodeED[i]:='????         ';

  opcodeED[ 64]:='IN   B,(C)   ';
  opcodeED[ 65]:='OUT  (C),B   ';
  opcodeED[ 66]:='SBC  HL,BC   ';
  opcodeED[ 67]:='LD   (n),BC 2';       //B changed to BC, LB
  opcodeED[ 68]:='NEG          ';
  opcodeED[ 69]:='RETN         ';
  opcodeED[ 70]:='IM   0       ';
  opcodeED[ 71]:='LD   I,A     ';
  opcodeED[ 72]:='IN   C,(C)   ';
  opcodeED[ 73]:='OUT  (C),C   ';
  opcodeED[ 74]:='ADC  HL,BC   ';
  opcodeED[ 75]:='LD   BC,(n) 2';       //closing parenthesis added by LB
  opcodeED[ 77]:='RETI         ';
  opcodeED[ 79]:='LD   R,A     ';
  opcodeED[ 80]:='IN   D,(C)   ';
  opcodeED[ 81]:='OUT  (C),D   ';
  opcodeED[ 82]:='SBC  HL,DE   ';
  opcodeED[ 83]:='LD   (n),DE 2';
  opcodeED[ 86]:='IM   1       ';
  opcodeED[ 87]:='LD   A,I     ';
  opcodeED[ 88]:='IN   E,(C)   ';
  opcodeED[ 89]:='OUT  (C),E   ';
  opcodeED[ 90]:='ADC  HL,DE   ';
  opcodeED[ 91]:='LD   DE,(n) 2';
  opcodeED[ 94]:='IM   2       ';
  opcodeED[ 95]:='LD   A,R     ';
  opcodeED[ 96]:='IN   H,(C)   ';
  opcodeED[ 97]:='OUT  (C),H   ';
  opcodeED[ 98]:='SBC  HL,HL   ';
  opcodeED[ 99]:='LD   (n),HL 2';
  opcodeED[103]:='RRD          ';
  opcodeED[104]:='IN   L,(C)   ';
  opcodeED[105]:='OUT  (C),L   ';
  opcodeED[106]:='ADC  HL,HL   ';
  opcodeED[107]:='LD   HL,(n) 2';
  opcodeED[111]:='RLD          ';
  opcodeED[114]:='SBC  HL,SP   ';
  opcodeED[115]:='LD   (n),SP 2';
  opcodeED[120]:='IN   A,(C)   ';
  opcodeED[121]:='OUT  (C),A   ';
  opcodeED[122]:='ADC  HL,SP   ';
  opcodeED[123]:='LD   SP,(n) 2';
  opcodeED[160]:='LDI          ';
  opcodeED[161]:='CPI          ';
  opcodeED[162]:='INI          ';
  opcodeED[163]:='OUTI         ';
  opcodeED[168]:='LDD          ';
  opcodeED[169]:='CPD          ';
  opcodeED[170]:='IND          ';
  opcodeED[171]:='OUTD         ';
  opcodeED[176]:='LDIR         ';
  opcodeED[177]:='CPIR         ';
  opcodeED[178]:='INIR         ';
  opcodeED[179]:='OTIR         ';
  opcodeED[184]:='LDDR         ';
  opcodeED[185]:='CPDR         ';
  opcodeED[186]:='INDR         ';
  opcodeED[187]:='OTDR         ';


  for i:=0 to 255 do opcodeFD[i]:='????         ';

  opcodeFD[  9]:='ADD  IY,BC   ';
  opcodeFD[ 25]:='ADD  IY,DE   ';
  opcodeFD[ 33]:='LD   IY,n   2';
  opcodeFD[ 34]:='LD   (n),IY 2';
  opcodeFD[ 35]:='INC  IY      ';
  opcodeFD[ 41]:='ADD  IY,IY   ';
  opcodeFD[ 42]:='LD   IY,(n) 2';
  opcodeFD[ 43]:='DEC  IY      ';
  opcodeFD[ 52]:='INC  (IY+n) 1';
  opcodeFD[ 53]:='DEC  (IY+n) 1';
  opcodeFD[ 54]:='LD  (IY+i),n4';
  opcodeFD[ 57]:='ADD  IY,SP   ';
  opcodeFD[ 70]:='LD  B,(IY+n)1';
  opcodeFD[ 78]:='LD  C,(IY+n)1';
  opcodeFD[ 86]:='LD  D,(IY+n)1';
  opcodeFD[ 94]:='LD  E,(IY+n)1';
  opcodeFD[102]:='LD  H,(IY+n)1';
  opcodeFD[110]:='LD  HL(IY+n)1';
  opcodeFD[112]:='LD  (IY+n),B1';
  opcodeFD[113]:='LD  (IY+n),C1';
  opcodeFD[114]:='LD  (IY+n),D1';
  opcodeFD[115]:='LD  (IY+n),E1';
  opcodeFD[116]:='LD  (IY+n),H1';
  opcodeFD[117]:='LD  (IY+n),L1';
  opcodeFD[119]:='LD  (IY+n),A1';
  opcodeFD[126]:='LD  A,(IY+n)1';
  opcodeFD[134]:='ADD A,(IY+n)1';
  opcodeFD[142]:='ADC A,(IY+n)1';
  opcodeFD[150]:='SUB  (IY+n) 1';
  opcodeFD[158]:='SBC A,(IY+n)1';
  opcodeFD[166]:='AND  (IY+n) 1';
  opcodeFD[174]:='XOR  (IY+n) 1';
  opcodeFD[182]:='OR   (IY+n) 1';
  opcodeFD[190]:='CP   (IY+n) 1';
  opcodeFD[203]:='???         9';
  opcodeFD[225]:='POP IY       ';
  opcodeFD[227]:='EX   (SP),IY ';
  opcodeFD[229]:='PUSH IY      ';
  opcodeFD[233]:='JP   (IY)    ';
  opcodeFD[249]:='LD   SP,IY   ';

  opcodeFDCB[  6]:='RLC  (IY+n) 1';
  opcodeFDCB[ 14]:='RRC  (IY+n) 1';
  opcodeFDCB[ 22]:='RL   (IY+n) 1';
  opcodeFDCB[ 30]:='RR   (IY+n) 1';
  opcodeFDCB[ 38]:='SLA  (IY+n) 1';
  opcodeFDCB[ 46]:='SRA  (IY+n) 1';
  opcodeFDCB[ 62]:='SRL  (IY+n) 1';
  opcodeFDCB[ 70]:='BIT 0,(IY+n)1';
  opcodeFDCB[ 78]:='BIT 1,(IY+n)1';
  opcodeFDCB[ 86]:='BIT 2,(IY+n)1';
  opcodeFDCB[ 94]:='BIT 3,(IY+n)1';
  opcodeFDCB[102]:='BIT 4,(IY+n)1';
  opcodeFDCB[110]:='BIT 5,(IY+n)1';
  opcodeFDCB[118]:='BIT 6,(IY+n)1';
  opcodeFDCB[126]:='BIT 7,(IY+n)1';
  opcodeFDCB[134]:='RES 0,(IY+n)1';
  opcodeFDCB[142]:='RES 1,(IY+n)1';
  opcodeFDCB[150]:='RES 2,(IY+n)1';
  opcodeFDCB[158]:='RES 3,(IY+n)1';
  opcodeFDCB[166]:='RES 4,(IY+n)1';
  opcodeFDCB[174]:='RES 5,(IY+n)1';
  opcodeFDCB[182]:='RES 6,(IY+n)1';
  opcodeFDCB[190]:='RES 7,(IY+n)1';
  opcodeFDCB[198]:='SET 0,(IY+n)1';
  opcodeFDCB[206]:='SET 1,(IY+n)1';
  opcodeFDCB[214]:='SET 2,(IY+n)1';
  opcodeFDCB[222]:='SET 3,(IY+n)1';
  opcodeFDCB[230]:='SET 4,(IY+n)1';
  opcodeFDCB[238]:='SET 5,(IY+n)1';
  opcodeFDCB[246]:='SET 6,(IY+n)1';
  opcodeFDCB[254]:='SET 7,(IY+n)1';
end;



end.
